  #Include "WIN32API.INC"
  
  Global gTimerBase As Long
  Global gTimerLoop As Long
  Global gTimerMSec As Long
  Global gTimerElap As Long
  Global gTimerHwnd As Long
  Global gTimerTitle As String
  Global gTimerFmt   As String
  
  Global gTimerLoopWindow As Long
  
  '=========================================================
  Function MessageBoxTimer(   _
                              ByVal hWnd    As Dword      , _
                              ByVal uiMsg   As Dword      , _
                              ByVal idEvent As Dword      , _
                              ByVal dwTime  As Dword        _
                            ) As Long

    Dim szTitle   As Asciiz * 256
    Dim sTitle    As String
    Dim lTitleLen As Long
    Dim lPos      As Long 
    Dim TimeRemain  As Double
        
    If gTimerHwnd = 0& Then
      gTimerHwnd = GetForegroundWindow()
    End If   
    Select Case Long idEvent
      Case gTimerBase
        PostQuitMessage 0
        Function = 0     
        gTimerHwnd = 0&
      Case gTimerLoop
        If gTimerHwnd <> 0& Then

          lTitleLen = GetWindowText ( _
                                      gTimerHwnd, _
                                      szTitle, _
                                      SizeOf(szTitle) _
                                    )

          gTimerElap = gTimerElap + gTimerLoopWindow                                    
          TimeRemain = gTimerMSec - gTimerElap
          lPos = InStr(gTimerTitle, "%t")  
          If lPos Then
            sTitle = gTimerTitle
            Replace "%t" With Format$((TimeRemain / 1000), gTimerFmt) In sTitle
          Else 
            sTitle = gTimerTitle + Format$((TimeRemain / 1000), gTimerFmt)
          End If
          
          SetWindowText gTimerHwnd, ByCopy sTitle
          
        End If

    End Select
    
  End Function

  '=========================================================
  Function TimedMessageBox(   ByVal hWnd As Dword         , _
                              ptszMessage As Asciiz       , _
                              ptszTitle As Asciiz         , _
                              ByVal flags As Dword        , _
                              ByVal lmSec As Long         , _
                              ByVal lmSecRefresh As Long  , _
                              ByVal sRefreshFmt As String   _
                            ) As Long
    '
    Dim iResult       As Long
    Dim Msg           As tagMsg
    Dim TimerProcPtr  As Dword
    Dim PrevActiveWin As Long
    Dim TimerBase     As Long
    Dim TimerLoop     As Long
    Dim lPos          As Long
    
    '
    PrevActiveWin = GetForegroundWindow()

    If lmSec > 0 Then
      TimerProcPtr = CodePtr(MessageBoxTimer)

      TimerBase = SetTimer(0, 0, lmSec, TimerProcPtr)
      If lmSecRefresh > 0 Then                           
        gTimerLoopWindow = lmSecRefresh
        TimerLoop = SetTimer(0, 0, gTimerLoopWindow, TimerProcPtr)
      End If
      gTimerElap = 0&      
      gTimerMSec = lmSec
      gTimerBase = TimerBase
      gTimerLoop = TimerLoop

    Else
      gTimerMSec = 0
      gTimerBase = 0
      gTimerLoop = 0      
    End If
    
    gTimerHwnd = 0&
    gTimerTitle = ptszTitle
    gTimerFmt   = sRefreshFmt

    If lmSec Then
          lPos = InStr(ptszTitle, "%t")  
          If lPos Then
            Replace "%t" With Format$((lmSec / 1000), gTimerFmt) In ptszTitle
          Else 
            ptszTitle = ptszTitle + Format$((lmSec / 1000), sRefreshFmt)
          End If 
    End If
    Function = MessageBox(hWnd, ptszMessage, ptszTitle, flags)

    If lmSec > 0 Then
      KillTimer 0, TimerBase
      KillTimer 0, TimerLoop

      iResult= PeekMessage(Msg, %Null, %WM_QUIT, %WM_QUIT, %PM_REMOVE)

      If iResult Then Function = %IDTIMEOUT

    End If
    
    gTimerElap = 0
    gTimerHwnd = 0
    gTimerMSec = 0
    gTimerBase = 0
    gTimerLoop = 0
    gTimerLoopWindow = 0 
    gTimerTitle = ""
    gTimerFmt   = ""     

    SetForegroundWindow PrevActiveWin

  End Function
  '=========================================================
  
  Function PBMain() As Long
    Local lReturn As Long
    

    lReturn = TimedMessageBox ( _
                                0            , _   'No Parent
                                "Any message, bla, bla, bla, bla, bla ...."             , _   'Message to display
                                "Message will be out in %t secs"               , _   'Title
                                0             , _   'How to display it
                                5000             , _   'Milliseconds to wait
                                1000        , _
                                "#0"         _
                              )

  End Function

  